/*  FILE    hex.ch
* Author    Chuck Burfoot
* Created   Sun  12-02-1990
* Mod
*
* Mod       Thu  04-22-1993  - Added dp_hex() translation, but don't know
*           How usefull it will be.
*
* Purpose   Standard defines for HEX numbering
*           Definitions to use in lieu of calculating the decimal
            equivalent and always wondering when we read it if it is
            the correct value.

    Would be fastest if we could #define all values up to xFFFF,
    BUT would take about 256 K to read in the file, so doesn't seem
    pratical. Wish Clipper Compiler could translate HEX notation
*
*           Copyright Codesmythe, Inc. 1993
            Copyright, Charles A. Burfoot, 1991
            All Rights Reserved
*** */

/* Number defines in HEX - ONLY up to 255  - x0FF
   FOR values greater than 255 (xFF) see  B2INT(xValue) --> nValue

    eg: x1234h = B2INT(x12)+x34

    The following works, but it isn't very obvious or handy  */

#xtranslate dp_hex( <x>,<y> ) => (B2INT( x<x> ) + x<y>)

#define   x0      0
#define   x1      1
#define   x2      2
#define   x3      3
#define   x4      4
#define   x5      5
#define   x6      6
#define   x7      7
#define   x8      8
#define   x9      9
#define  x0A     10
#define  x0B     11
#define  x0C     12
#define  x0D     13
#define  x0E     14
#define  x0F     15
#define  x10     16
#define  x11     17
#define  x12     18
#define  x13     19
#define  x14     20
#define  x15     21
#define  x16     22
#define  x17     23
#define  x18     24
#define  x19     25
#define  x1A     26
#define  x1B     27
#define  x1C     28
#define  x1D     29
#define  x1E     30
#define  x1F     31
#define  x20     32
#define  x21     33
#define  x22     34
#define  x23     35
#define  x24     36
#define  x25     37
#define  x26     38
#define  x27     39
#define  x28     40
#define  x29     41
#define  x2A     42
#define  x2B     43
#define  x2C     44
#define  x2D     45
#define  x2E     46
#define  x2F     47
#define  x30     48
#define  x31     49
#define  x32     50
#define  x33     51
#define  x34     52
#define  x35     53
#define  x36     54
#define  x37     55
#define  x38     56
#define  x39     57
#define  x3A     58
#define  x3B     59
#define  x3C     60
#define  x3D     61
#define  x3E     62
#define  x3F     63
#define  x40     64
#define  x41     65
#define  x42     66
#define  x43     67
#define  x44     68
#define  x45     69
#define  x46     70
#define  x47     71
#define  x48     72
#define  x49     73
#define  x4A     74
#define  x4B     75
#define  x4C     76
#define  x4D     77
#define  x4E     78
#define  x4F     79
#define  x50     80
#define  x51     81
#define  x52     82
#define  x53     83
#define  x54     84
#define  x55     85
#define  x56     86
#define  x57     87
#define  x58     88
#define  x59     89
#define  x5A     90
#define  x5B     91
#define  x5C     92
#define  x5D     93
#define  x5E     94
#define  x5F     95
#define  x60     96
#define  x61     97
#define  x62     98
#define  x63     99
#define  x64    100
#define  x65    101
#define  x66    102
#define  x67    103
#define  x68    104
#define  x69    105
#define  x6A    106
#define  x6B    107
#define  x6C    108
#define  x6D    109
#define  x6E    110
#define  x6F    111
#define  x70    112
#define  x71    113
#define  x72    114
#define  x73    115
#define  x74    116
#define  x75    117
#define  x76    118
#define  x77    119
#define  x78    120
#define  x79    121
#define  x7A    122
#define  x7B    123
#define  x7C    124
#define  x7D    125
#define  x7E    126
#define  x7F    127
#define  x80    128
#define  x81    129
#define  x82    130
#define  x83    131
#define  x84    132
#define  x85    133
#define  x86    134
#define  x87    135
#define  x88    136
#define  x89    137
#define  x8A    138
#define  x8B    139
#define  x8C    140
#define  x8D    141
#define  x8E    142
#define  x8F    143
#define  x90    144
#define  x91    145
#define  x92    146
#define  x93    147
#define  x94    148
#define  x95    149
#define  x96    150
#define  x97    151
#define  x98    152
#define  x99    153
#define  x9A    154
#define  x9B    155
#define  x9C    156
#define  x9D    157
#define  x9E    158
#define  x9F    159
#define  x0A0   160
#define  x0A1   161
#define  x0A2   162
#define  x0A3   163
#define  x0A4   164
#define  x0A5   165
#define  x0A6   166
#define  x0A7   167
#define  x0A8   168
#define  x0A9   169
#define  x0AA   170
#define  x0AB   171
#define  x0AC   172
#define  x0AD   173
#define  x0AE   174
#define  x0AF   175
#define  x0B0   176
#define  x0B1   177
#define  x0B2   178
#define  x0B3   179
#define  x0B4   180
#define  x0B5   181
#define  x0B6   182
#define  x0B7   183
#define  x0B8   184
#define  x0B9   185
#define  x0BA   186
#define  x0BB   187
#define  x0BC   188
#define  x0BD   189
#define  x0BE   190
#define  x0BF   191
#define  x0C0   192
#define  x0C1   193
#define  x0C2   194
#define  x0C3   195
#define  x0C4   196
#define  x0C5   197
#define  x0C6   198
#define  x0C7   199
#define  x0C8   200
#define  x0C9   201
#define  x0CA   202
#define  x0CB   203
#define  x0CC   204
#define  x0CD   205
#define  x0CE   206
#define  x0CF   207
#define  x0D0   208
#define  x0D1   209
#define  x0D2   210
#define  x0D3   211
#define  x0D4   212
#define  x0D5   213
#define  x0D6   214
#define  x0D7   215
#define  x0D8   216
#define  x0D9   217
#define  x0DA   218
#define  x0DB   219
#define  x0DC   220
#define  x0DD   221
#define  x0DE   222
#define  x0DF   223
#define  x0E0   224
#define  x0E1   225
#define  x0E2   226
#define  x0E3   227
#define  x0E4   228
#define  x0E5   229
#define  x0E6   230
#define  x0E7   231
#define  x0E8   232
#define  x0E9   233
#define  x0EA   234
#define  x0EB   235
#define  x0EC   236
#define  x0ED   237
#define  x0EE   238
#define  x0EF   239
#define  x0F0   240
#define  x0F1   241
#define  x0F2   242
#define  x0F3   243
#define  x0F4   244
#define  x0F5   245
#define  x0F6   246
#define  x0F7   247
#define  x0F8   248
#define  x0F9   249
#define  x0FA   250
#define  x0FB   251
#define  x0FC   252
#define  x0FD   253
#define  x0FE   254
#define  x0FF   255

#define  x0080  128     // Equal to B2INT(x1) but faster at runtime

#define  x0100  256     // Equal to B2INT(x1)+x0 but faster at runtime
#define  x0101  257     // Equal to B2INT(x1)+x1 but faster at runtime
#define  x0102  258     // Equal to B2INT(x1)+x2 but faster at runtime
#define  x0103  259     // Equal to B2INT(x1)+x3 but faster at runtime
#define  x0104  260     // Equal to B2INT(x1)+x4 but faster at runtime
#define  x0105  261     // Equal to B2INT(x1)+x5 but faster at runtime

#define  x1000 4096    // Equal to B2INT(x10) but faster

/*--<EOF  hex.ch >--*/
