/*  FILE    regs.ch
* Author    Chuck Burfoot
* Created   Wed  05-08-1991
* Mod
*
* Mod       Thu  04-22-1993  - Set up system wide defines for the
*           code blocks and DP_* calls for direct df_dos() calls (ie,
*           #def I_CONTROL ) and default indirect access calls (ie,
*           df_calldos() ) configurations
*
* Purpose   Defines for CPU REGISTER ACCESS for the Function Calls
*
*           Copyright Codesmythe, Inc. 1993
            Copyright, Charles A. Burfoot, 1991
            All Rights Reserved

*** */

#ifndef x0A
   #include "hex.ch"
#endif


#ifndef _AX

   // Common defines

   #define OFFSET   -1

   #xtranslate HIGHBYTE(<x>) =>   ((<x>)/256)
   #xtranslate LOWBYTE(<x>)  =>   ((<x>)%256)
   #xtranslate B2INT(<x>)    =>   ((<x>)*256)
   #xtranslate DP_HIGHNIB(<x>) =>   (df_maskbit(1,((<x>)%255),240)/16)
   #xtranslate DP_LOWNIB(<x>) =>   (df_maskbit(1,((<x>)%255),15))

   #define AND_BITS         1           // Used with the MASKBIT() Function
   #define OR_BITS          2
   #define NEG_BITS         3
   #define NOT_BITS         4
   #define XOR_BITS         8

   #define D_NONDRIVE       0
   #define D_HARDDRIVE     10
   #define D_FLOPDRIVE     11
   #define D_RAMDRIVE      12
   #define D_NETDRIVE      20
   #define D_NETFLOPPY     21

   #define REGSCOUNT        8

   #xtranslate geninterrupt( <x> )  => df_calldos( <x> )

   #ifndef I_CONTROLL             // Uncomment for automatic selfcontrol
//     #define I_CONTROLL
   #endif


   #ifdef I_CONTROLL

      #xtranslate USES <scope> REGISTERS    =>  <scope> REGS[ REGSCOUNT ]

      #xtranslate _AX [ := <x> ]    =>  REGS\[1] [ := <x> ]
      #xtranslate _AH               =>  INT(REGS\[1\] /256)
      #xtranslate _AH := <x>        =>  INT((REGS\[1\] := df_regfix( 2, <x>, REGS\[1\] ) )/256)
      #xtranslate _AL               =>  INT( REGS\[1] %256)
      #xtranslate _AL := <x>        =>  INT((REGS\[1] := df_regfix( 1 , <x>, REGS\[1] ) )%256)

      #xtranslate _BX [ := <x> ]    =>  REGS\[2] [ := <x> ]
      #xtranslate _BH               =>  INT( REGS\[2] / 256 )
      #xtranslate _BH := <x>        =>  INT((REGS\[2] := df_regfix( 2 , <x>, REGS\[2] ) )/256 )
      #xtranslate _BL               =>  INT( REGS\[2] % 256 )
      #xtranslate _BL := <x>        =>  INT((REGS\[2] := df_regfix( 1 , <x>, REGS\[2] ) )%256 )

      #xtranslate _CX [ := <x> ]    =>   REGS\[3] [ := <x> ]
      #xtranslate _CH               =>  INT( REGS\[3] / 256 )
      #xtranslate _CH := <x>        =>  INT((REGS\[3] := df_regfix( 2 , <x>, REGS\[3] ) )/256 )
      #xtranslate _CL               =>  INT( REGS\[3] % 256 )
      #xtranslate _CL := <x>        =>  INT((REGS\[3] := df_regfix( 1 , <x>, REGS\[3] ) )%256 )

      #xtranslate _DX [ := <x> ]    =>   REGS[4]  [ := <x> ]
      #xtranslate _DH               =>  INT( REGS\[4] / 256 )
      #xtranslate _DH := <x>        =>  INT((REGS\[4] := df_regfix( 2 , <x>, REGS\[4] ) )/256 )
      #xtranslate _DL               =>  INT( REGS\[4] % 256 )
      #xtranslate _DL := <x>        =>  INT((REGS\[4] := df_regfix( 1 , <x>, REGS\[4] ) )%256 )

      #xtranslate _SI [ := <x> ]    =>   REGS[5]  [ := <x> ] // Not usual to access
      #xtranslate _DI [ := <x> ]    =>   REGS[6]  [ := <x> ] // BUT IF NEED IT

      #define _FLAGS  REGS[7]       // Assignment not allowed
      #define _FL  (REGS[7]%256)    // in this implementation

      #xtranslate _BP [ := <x> ]    =>   REGS[8] [ := <x> ]

      #define _C_FLAG  isbit(0,REGS[7])      // (Carry flag)
      #define _P_FLAG  isbit(2,REGS[7])      // (Parity flag)
      #define _A_FLAG  isbit(4,REGS[7])      // (Auxilary flag)
      #define _Z_FLAG  isbit(6,REGS[7])      // (zero flag - set when result of math is 0)
      #define _S_FLAG  isbit(7,REGS[7])      // (sign flag)
      #define _T_FLAG  isbit(8,REGS[7])      // (trap flag - set with INT 3)
      #define _I_FLAG  isbit(9,REGS[7])      // (interrupt flag - not settable)
      #define _D_FLAG  isbit(10,REGS[7])     // (divide flag - set on divide by 0 error)
      #define _O_FLAG  isbit(11,REGS[7])     // (overflow flag - set when a REG overflow's)
      #define _NT_FLAG isbit(14,REGS[7])     // (Nested Task flag - ? 386/486 Only )

      #xtranslate USES <scope> SEGMENT REGISTERS    =>  <scope> SREGS[ 2 ]

      #xtranslate _DS [ := <str> ]               =>     SREGS\[1] [ := <str> ]
      #xtranslate _ES [ := <str> ]               =>     SREGS\[2] [ := <str> ]

   #else

      #xtranslate USES <scope> REGISTERS         =>

      #xtranslate USES <scope> SEGMENT REGISTERS =>

      #xtranslate _AX [ := <x> ]    =>   DF_REGS( 1 [,1,<x>]  )
      #xtranslate _AH [ := <x> ]    =>   INT( DF_REGS( 1 [,1,df_regfix( 2, <x> , DF_REGS(1) )] )/256)
      #xtranslate _AL [ := <x> ]    =>   INT( DF_REGS( 1 [,1,df_regfix( 1, <x> , DF_REGS(1) )] )%256)

      #xtranslate _BX [ := <x> ]    =>   DF_REGS( 2 [,1, <x> ] )
      #xtranslate _BH [ := <x> ]    =>   INT( DF_REGS( 2 [,1,df_regfix( 2, <x> , DF_REGS(2) )] )/256)
      #xtranslate _BL [ := <x> ]    =>   INT( DF_REGS( 2 [,1,df_regfix( 1, <x> , DF_REGS(2) )] )%256)

      #define _CX  DF_REGS(3)
      #xtranslate _CH [ := <x> ]    =>   INT( DF_REGS( 3 [,1,df_regfix( 2, <x> , DF_REGS(3) )] )/256)
      #xtranslate _CL [ := <x> ]    =>   INT( DF_REGS( 3 [,1,df_regfix( 1, <x> , DF_REGS(3) )] )%256)

      #define _DX  DF_REGS(4)
      #xtranslate _DH [ := <x> ]    =>   INT( DF_REGS( 4 [,1,df_regfix( 2, <x> , DF_REGS(4) )] )/256)
      #xtranslate _DL [ := <x> ]    =>   INT( DF_REGS( 4 [,1,df_regfix( 1, <x> , DF_REGS(4) )] )%256)

      #xtranslate _SI [ := <x> ]    =>   DF_REGS(5 [,1,<x>] )
      #xtranslate _DI [ := <x> ]    =>   DF_REGS(6 [,1,<x>] )

      #define _FLAGS  DF_REGS(7)
      #define _FL  INT(DF_REGS(7)%256)

      #xtranslate _BP [ := <x> ]    =>   DF_REGS(8 [,1,<x> ] )

      #define _C_FLAG  isbit(0,DF_REGS(7))      // (Carry flag)
      #define _P_FLAG  isbit(2,DF_REGS(7))      // (Parity flag)
      #define _A_FLAG  isbit(4,DF_REGS(7))      // (Auxilary flag)
      #define _Z_FLAG  isbit(6,DF_REGS(7))      // (zero flag - set when result of math is 0)
      #define _S_FLAG  isbit(7,DF_REGS(7))      // (sign flag)
      #define _T_FLAG  isbit(8,DF_REGS(7))      // (trap flag - set with INT 3)
      #define _I_FLAG  isbit(9,DF_REGS(7))      // (interrupt flag - not settable)
      #define _D_FLAG  isbit(10,DF_REGS(7))     // (divide flag - set on divide by 0 error)
      #define _O_FLAG  isbit(11,DF_REGS(7))     // (overflow flag - set when REG overflow's)
      #define _NT_FLAG isbit(14,DF_REGS(7))     // (Nested Task flag - ? 386/486 Only )

      #xtranslate _DS [ := <x> ]    =>   DF_REGS( 1 , 2 [, <x> ] )
      #xtranslate _ES [ := <x> ]    =>   DF_REGS( 2 , 2 [, <x> ] )

   #endif

/*--<EOF  regs.ch >--*/
